#include <OneWire.h>
#include <DallasTemperature.h>
#include <Wire.h>
#include <BMP085.h>
#include <VirtualWire.h>
#include <EasyTransferVirtualWire.h>
#include <LiquidCrystal.h>


LiquidCrystal lcd(6, 7, 8, 9, 10, 11); // Назначение портов LCD 
BMP085 dps = BMP085();   
//long Temperature = 0, Pressure = 0, Altitude = 0;


// Data wire is plugged into port 4 on the Arduino
#define ONE_WIRE_BUS 4
// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);
// Pass our oneWire reference to Dallas Temperature. 
DallasTemperature sensors(&oneWire);

//-----------------------------
EasyTransferVirtualWire ET; 
struct SEND_DATA_STRUCTURE {
  //put your variable definitions here for the data you want to send
  //THIS MUST BE EXACTLY THE SAME ON THE OTHER ARDUINO
  //Struct can'e be bigger then 26 bytes for VirtualWire version
  byte ID;
  long TemperatureBMP = 0;
  long TemperatureDS = 0; 
  long Pressure = 0;
  
  };
//give a name to the group of data
SEND_DATA_STRUCTURE mydata;
void setup(void)
{
  // start serial port
  Serial.begin(9600);
   // Start up the library
  sensors.begin();
  
  lcd.begin(8,2); 
  Wire.begin();
  delay(1000);
  dps.init(MODE_STANDARD, 2500, true);
//dps.init();

//работа с 433мгц
//start the library, pass in the data details
  ET.begin(details(mydata));
  mydata.ID = 1;
  // Initialise the IO and ISR
  vw_set_ptt_inverted(true); // Required for DR3100
  vw_set_tx_pin(5);
  vw_setup(2000);  // Bits per sec
  
   
  randomSeed(analogRead(0));


}

void loop(void)
{ 
   lcd.setCursor(1,0);
  sensors.requestTemperatures(); // Send the command to get temperatures
   
  lcd.print("T1: ");
  lcd.setCursor(0,1)
  lcd.print(sensors.getTempCByIndex(0));
  delay(3000);
  //BMP180
  dps.getPressure(&Pressure);
  dps.getTemperature(&Temperature);
  lcd.setCursor(1,0);
  lcd.print(Pressure/133.3);
  lcd.print("");
   
  lcd.setCursor(0,1); 
  lcd.print(Temperature*0.1);
  lcd.print ("");    
  delay(5000);
  
   //this is how you access the variables. [name of the group].[variable name]
  mydata.TemperatureBMP = (Temperature*0.1)*100;
  mydata.TemperatureDS = (sensors.getTempCByIndex(0))*100;
  mydata.Pressure = (Pressure/133.3)*100;
  
  ET.sendData();
 
  delay(random(5000, 10000));

}
