#include <OneWire.h>
#include <Wire.h>
#include <BMP085.h>
#include <VirtualWire.h>
#include <EasyTransferVirtualWire.h>
#include "DHT.h"

BMP085 dps = BMP085();   
long TempDHT = 0;
long HumDHT = 0;
long Pressure = 0;

#define DHTPIN 9
#define DHTTYPE DHT22
DHT dht(DHTPIN, DHTTYPE);
// Data wire is plugged into port 4 on the Arduino

#define ONE_WIRE_BUS 4
// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);


//-----------------------------
EasyTransferVirtualWire ET; 
struct SEND_DATA_STRUCTURE {
  //put your variable definitions here for the data you want to send
  //THIS MUST BE EXACTLY THE SAME ON THE OTHER ARDUINO
  //Struct can'e be bigger then 26 bytes for VirtualWire version
  byte ID;
  long TempDHT = 0;
  long HumDHT = 0;  
  long Pressure = 0;
  
  };
//give a name to the group of data
SEND_DATA_STRUCTURE mydata1;
void setup(void)
{
  Serial.begin(9600);
  
  Wire.begin();
  delay(1000);
  dps.init(MODE_STANDARD, 2500, true);
//dps.init();

//работа с 433мгц
//start the library, pass in the data details
  ET.begin(details(mydata1));
  mydata1.ID = 1;
  // Initialise the IO and ISR
  vw_set_ptt_inverted(true); // Required for DR3100
  vw_set_tx_pin(5);
  vw_setup(2000);  // Bits per sec
    
  randomSeed(analogRead(0));


}

void loop(void)
{   
     
  //BMP180
  dps.getPressure(&Pressure);
 // dps.getTemperature(&Temperature);
   

 delay(500);
//DHT22
// Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  float h = dht.readHumidity();
  // Read temperature as Celsius (the default)
  float t = dht.readTemperature();
 
  
  mydata1.TempDHT = (t)*100;
  mydata1.HumDHT = (h)*100;
  mydata1.Pressure = (Pressure/133.3)*100;
   ET.sendData();
  
 /* Serial.print("Humidity: ");
  Serial.print(h);
  Serial.println("%");
  Serial.print("Temperature: ");
  Serial.print(t);
  Serial.println(" *C ");
  Serial.print ("Davlenie =");
  Serial.println ((Pressure/133.3));*/
   
  delay(random(5000, 8000));
  
}
