#include <SPI.h>           // Ethernet shield
#include <Ethernet.h>      // Ethernet shield
#include <PubSubClient.h>  // MQTT 
#include <VirtualWire.h>
#include <EasyTransferVirtualWire.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2);

byte mac[]    = { 0xC1, 0x7C, 0x38, 0x41, 0x89, 0x12 };
byte server[] = { 192, 168, 0, 102 }; //IP Брокера
byte ip[]     = { 192, 168, 0, 112 }; //IP Клиента (Arduino)

EthernetClient ethClient;
PubSubClient client(server, 1883, callback, ethClient);
#define id_connect "myhome-detskaya"
#define Prefix_subscribe "myhome/Detskaya/"

int pause = 0;
float Hout = 0;
float Tout = 0;
//create object
EasyTransferVirtualWire ET; 


struct SEND_DATA_STRUCTURE 
{
  //put your variable definitions here for the data you want to send
  //THIS MUST BE EXACTLY THE SAME ON THE OTHER ARDUINO
  //Struct can'e be bigger then 26 bytes for VirtualWire version
  byte ID;
  long TemperatureBMP = 0;
  long TemperatureDS = 0; 
  long Pressure = 0;

};

//give a name to the group of data
SEND_DATA_STRUCTURE mydata;
  byte ID;
  long TemperatureBMP = 0;
  long TemperatureDS = 0; 
  long Pressure = 0;


////////////////////////////////////////////////////////////////////////////
void callback(char* topic, byte* payload, unsigned int length) {
    payload[length] = '\0';
   // Serial.print(topic);
   // Serial.print("=");
    String strTopic = String(topic);
    String strPayload = String((char*)payload);
   // Serial.println(strPayload);
  //  callback_iobroker(strTopic, strPayload);
}
void setup(){
  //start the library, pass in the data details
  ET.begin(details(mydata));
  Serial.begin(9600);
  // Initialise the IO and ISR
  vw_set_ptt_inverted(true); // Required for DR3100 
  vw_setup(2000);      // Bits per sec Скорость порта
  vw_set_rx_pin(8);    //порт к которому подключен приемник 433 мГц
  vw_rx_start();       // Start the receiver PLL running
 
  lcd.init(); // Инициализируем экран
  lcd.backlight(); //Включаем подсветку
  
   Ethernet.begin(mac, ip);
  if (client.connect(id_connect)) {
//    getSensors();
//    control();
   // client.publish("myhome/Kitchen/Change_Counter", "0");
   // client.publish("myhome/Kitchen/Temp_room", "0");
   // client.publish("myhome/Kitchen/Humidity_room", "0");
   // client.publish("myhome/Kitchen/Temp_radiator", "0");
   // client.publish("myhome/Kitchen/Temp_in", "0");
   // client.publish("myhome/Kitchen/Lux", "0");
   // client.publish("myhome/Kitchen/Servo", "0");
   // client.publish("myhome/Kitchen/MQ7", "0");
    
    client.subscribe("myhome/Detskaya/#");
  }
  
}

void loop(){
 
  //check and see if a data packet has come in. 
  if(ET.receiveData()){
    //this is how you access the variables. [name of the group].[variable name]
    //since we have data, we will blink it out. 
    if (mydata.ID == 1)
    {
       int TempBMP= (mydata.TemperatureBMP);
       TempBMP = ((TempBMP)/100);
       float TempDS= (mydata.TemperatureDS);
       TempDS = ((TempDS)/100);
       float Pressure2= (mydata.Pressure);
       Pressure2 = ((Pressure2)/100);
       
  // Serial.print(TempBMP);                                 //Вывод информации в COM порт   
 // Serial.println(", TempBMP:");
   // Температуру в градусах Цельсия
  Serial.print(TempDS);
  Serial.print(" C°,");
     // Температуру в градусах Цельсия  
  Serial.print(Pressure2);
  Serial.print(" mm/");
    //Выводим давление в мм.рт ст
  Serial.println();
  Serial.println();
  delay(1000);
  
                                      //Вывод информации на  LCD Экран
  lcd.clear();//очищаем экран от старых данных
  lcd.setCursor(0,0);//Устанавливаем курсор в начало первой строки
  lcd.print("T1:");//Выводим первую температуру
  lcd.print(TempDS);
  lcd.setCursor(8,0);// устанавливаем курсор на 8 позицию в первой строке
  lcd.print(" T2:");//Выводим вторую температуру
  lcd.print(TempBMP);
//аналогично выводим вторую строку
  lcd.setCursor(0,1);//Устанавливаем курсор в начало второй строки
  lcd.print("Davlenie:");//Выводим давление
  lcd.print(Pressure2);
 }

        // sprintf(buf, "GET /objects/?object=tempDet&op=m&m=tempChanged&t=%0d.%d", (int)TempBMP, abs(temp1));
       // sendHTTPRequest();
      // delay(500);
     //  sprintf(buf, "GET /objects/?object=tempDS18B20_1&op=m&m=tempChanged&t=%0d.%d", (int)TempDS, abs(temp2)); 
    //  sendHTTPRequest();
     
  }
 client.loop();
 
  if (!client.connected()) {
        if (client.connect(id_connect)) {
 if (pause == 50 || pause == 0){ 
   
  char b[5]; 
   String char_Hout = String(Hout);
   char_Hout.toCharArray(b,5);
 client.publish("myhome/Detskaya/TempDet", b);
    
String char_Tout = String(Tout);
char_Tout.toCharArray(b,5);
client.publish("myhome/Detskaya/Pressure", b);
client.subscribe("myhome/Detskaya/#");
        }
    }
}

