#include <SPI.h>           // Ethernet shield
#include <Ethernet.h>      // Ethernet shield
#include <PubSubClient.h>  // MQTT 
#include <VirtualWire.h>
#include <EasyTransferVirtualWire.h>
#include <Wire.h>
//#include <LiquidCrystal_I2C.h>
//LiquidCrystal_I2C lcd(0x27,16,2);
/// 
byte mac[]    = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED};
IPAddress ip(192, 168, 1, 120);
IPAddress server(192, 168, 1, 116);

void callback(char* topic, byte* payload, unsigned int length) {
     byte* p = (byte*)malloc(length);
    payload[length] = '\0';
    memcpy(p,payload,length);
    //Serial.print(topic);
   // Serial.print("=");
    String strTopic = String(topic);
    String strPayload = String((char*)payload);
    Serial.println(strPayload);
    callback_iobroker(strTopic, strPayload);
    // Free the memory
  free(p);
}
//

EthernetClient ethClient;
PubSubClient client(server, 1883, callback, ethClient);
#define id_connect "UNO"
#define Prefix_subscribe "UNO/Detskaya/"


EasyTransferVirtualWire ET; 

struct SEND_DATA_STRUCTURE 
{
  //put your variable definitions here for the data you want to send
  //THIS MUST BE EXACTLY THE SAME ON THE OTHER ARDUINO
  //Struct can'e be bigger then 26 bytes for VirtualWire version
  byte ID;
  long TemperatureBMP = 0;
  long TemperatureDS = 0; 
  long Pressure = 0;

};

//give a name to the group of data
SEND_DATA_STRUCTURE mydata;
  byte ID;
  long TemperatureBMP = 0;
  long TemperatureDS = 0; 
  long Pressure = 0;


void setup(){
   Serial.begin(57600);
   client.loop();
  Ethernet.begin(mac, ip);
  delay(1000);
  if (client.connect(id_connect)) {
      client.publish("UNO/Detskaya/Temp", "6");
      client.publish("UNO/Detskaya/Pressure", "2");
    client.subscribe("UNO/Detskaya/#");
    Serial.println("connecting...");
  } 
      delay(1000);

 
  ET.begin(details(mydata));
 
  
  // Initialise the IO and ISR
  vw_set_ptt_inverted(true); // Required for DR3100 
  vw_setup(2000);      // Bits per sec Скорость порта
  vw_set_rx_pin(8);    //порт к которому подключен приемник 433 мГц
  vw_rx_start();       // Start the receiver PLL running
 
 // lcd.init(); // Инициализируем экран
 // lcd.backlight(); //Включаем подсветку
 
  }

void loop(){
  
  if(ET.receiveData()){
    //this is how you access the variables. [name of the group].[variable name]
    //since we have data, we will blink it out. 
    if (mydata.ID == 1)
    {
       int TempBMP= (mydata.TemperatureBMP);
       TempBMP = ((TempBMP)/100);
       float TempDS= (mydata.TemperatureDS);
       TempDS = ((TempDS)/100);
       float Pressure2= (mydata.Pressure);
       Pressure2 = ((Pressure2)/100); 


  Serial.print(TempBMP);                                 //Вывод информации в COM порт   
  Serial.println(", TempBMP:");
   // Температуру в градусах Цельсия
  Serial.print(TempDS);
  Serial.print(" C°,");
     // Температуру в градусах Цельсия  
  Serial.print(Pressure2);
  Serial.print(" mm/");
    //Выводим давление в мм.рт ст
  Serial.println();
  Serial.println();
  delay(500);
 
/*                                      //Вывод информации на  LCD Экран
  lcd.clear();//очищаем экран от старых данных
  lcd.setCursor(0,0);//Устанавливаем курсор в начало первой строки
  lcd.print("T1:");//Выводим первую температуру
  lcd.print(TempDS);
  lcd.setCursor(8,0);// устанавливаем курсор на 8 позицию в первой строке
  lcd.print(" T2:");//Выводим вторую температуру
  lcd.print(TempBMP);
//аналогично выводим вторую строку
  lcd.setCursor(0,1);//Устанавливаем курсор в начало второй строки
  lcd.print("Davlenie:");//Выводим давление
  lcd.print(Pressure2);
  */
 
char b[5];
  client.loop();
  Ethernet.begin(mac, ip);
  delay(1000);
    if (!client.connected())
   {Serial.println("No Connect");
    
        if (client.connect(id_connect)) {
    
    String char_TempDS = String(TempDS);
    char_TempDS.toCharArray(b,5);
    client.publish("UNO/Detskaya/Temp", b);
    
    String char_Pressure2 = String(Pressure2);
    char_Pressure2.toCharArray(b,5);
    client.publish("UNO/Detskaya/Temp", b);
 
       }

}

}
}
}
/////////////////////////////////От Брокера//////////////////////////////////////////////
void callback_iobroker(String strTopic, String strPayload){
  if (strTopic == "UNO/Detskaya/Temp") {
    Serial.println(strPayload);
        if (strPayload == "123") {
           client.publish("UNO/Detskaya/Temp", "ОК");
            client.loop();
        } 
   }
}
